﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class GameManagerScript : MonoBehaviour {


	public float timeLeft;
	public Text countdown;
	public VibrationManager vibrator;

	public static float globalSpeed = 6.0f;

	public static int fractionOne = 0;
	public static int fractionTwo = 0;

	public AudioClip c30left;
	public AudioClip c10left;
	public AudioClip c5left;
	public AudioClip c4left;
	public AudioClip c3left;
	public AudioClip c2left;
	public AudioClip c1left;
	public AudioClip cgameOver;
	public AudioClip cletFightBegin;

	public AudioSource audioManagerSource;

	int counter = 0;

	void Start () 
	{
		fractionOne = 0;
		fractionTwo = 0;
		AusgangssituationAusgleichen ();
		StartCoroutine("Countdown");
		GetComponent<AudioSource> ().PlayOneShot (cletFightBegin);
	}

	void AusgangssituationAusgleichen ()
	{
		//Finde alle NPCs und zähle
		GameObject[] npcs;
		int i = 0;
		npcs = GameObject.FindGameObjectsWithTag ("NPC");
		//Debug.Log(npcs.Length+" NPCs in Scene");

		foreach (GameObject npc in npcs) 
		{
			if (i % 2 <= 0)
				npc.GetComponent<NPCScript> ().fraction = 1;
			else
				npc.GetComponent<NPCScript> ().fraction = 2;
			npc.GetComponent<NPCScript> ().StartAnimator ();
			i++;
		}
	}

	void Update(){
		if (timeLeft > 0)
			countdown.text = Mathf.RoundToInt(timeLeft).ToString();

		if (!audioManagerSource.isPlaying) {
			if (fractionOne < fractionTwo) {
				SceneManager.LoadScene ("winRed");
			} else if (fractionOne > fractionTwo) {
				SceneManager.LoadScene ("winGreen");
			} else
				SceneManager.LoadScene ("tie");
		}
	}
		
	IEnumerator Countdown (){

		for (;;)
		{
			timeLeft -= Time.deltaTime;
			if (timeLeft < 0) {
				GameOver ();
				break;
			}
			if (timeLeft < 31.0f && counter == 0) {
				GetComponent<AudioSource>().PlayOneShot(c30left);
				counter++;
			}
			if (timeLeft < 11.0f && counter == 1) {
				GetComponent<AudioSource>().PlayOneShot(c10left);
				counter++;
			}
			if (timeLeft < 6.0f && counter == 2) {
				GetComponent<AudioSource>().PlayOneShot(c5left);
				counter++;
			}
			if (timeLeft < 5.0f && counter == 3) {
				GetComponent<AudioSource>().PlayOneShot(c4left);
				counter++;
			}
			if (timeLeft < 4.0f && counter == 4) {
				GetComponent<AudioSource>().PlayOneShot(c3left);
				counter++;
			}
			if (timeLeft < 3.0f && counter == 5) {
				GetComponent<AudioSource>().PlayOneShot(c2left);
				counter++;
			}
			if (timeLeft < 2.0f && counter == 6) {
				GetComponent<AudioSource>().PlayOneShot(c1left);
				counter++;
			}
			if (timeLeft < 1.0f && counter == 7) {
				GetComponent<AudioSource>().PlayOneShot(cgameOver);
				counter++;
			}
				
			yield return null;
		}

	}

	void GameOver()
	{
		Debug.Log ("Game over");

		countdown.text = "Game Over";
		globalSpeed = 0.0f;
		Time.timeScale = 0.0f;

		vibrator.VibrationToeten ();

		GameObject[] npcs;

		//Finde alle NPCs und zähle
		npcs = GameObject.FindGameObjectsWithTag ("NPC");
		Debug.Log (npcs.Length);

		foreach (GameObject npc in npcs) {
			npc.GetComponent<KI_Movement> ().StoppPlayback ("Stopp");
			if (npc.GetComponent<NPCScript> ().fraction == 1) {
				fractionOne++;
			} else
				fractionTwo++;
		}

		Debug.Log ("Fraction 1: " + fractionOne);
		Debug.Log ("Fraction 2: " + fractionTwo);
	}
}
