﻿using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;

public class KI_Movement : MonoBehaviour {

	// Use this for initialization
    Transform myTransform;
    public bool recActive = false;
    public bool playbackActive = false;
    public int listLength;
    public int i = 0;
    public int ExportID;
    public int Amount;
	float xDirection = 0.0f;
	float yDirection = 0.0f;
	public bool vulnerable = true;

    public Vector3 prevPos;
	Animator anim;
	SpriteRenderer spriteR;

    List<Vector3> loadedList = new List<Vector3>();
     private string FilePath;
         public Movement myMovement;
[System.Serializable]
         public class Movement {
             public List<Vector3> myMovementList;
             /* public Movement(List<Vector3> inputList){
             myMovementList = inputList;
             } */
         }
	void Start () {
		myTransform = gameObject.GetComponent<Transform>();
	
		FilePath = "save"+ ExportID;
        //print (FilePath);
        prevPos = myTransform.position;
        Initiate();

		anim = GetComponent<Animator>();
		spriteR = GetComponent<SpriteRenderer>();
	}
	
	// Update is called once per frame
	public float speed = 6.0F;
    private Vector3 moveDirection = Vector3.zero;
    public List<Vector3> listOfPosition = new List<Vector3>();

    void Update() {
        CharacterController controller = GetComponent<CharacterController>();
        if (recActive == true) {
			moveDirection = new Vector3(Input.GetAxis("Horizontal_JOYSTICK_1"), Input.GetAxis("Vertical_JOYSTICK_1"));
			this.transform.position = new Vector3(transform.position.x,transform.position.y, transform.position.y);
            moveDirection = transform.TransformDirection(moveDirection);
            moveDirection *= speed;
            
        }
        controller.Move(moveDirection * Time.deltaTime);

        if (recActive == true){
            listOfPosition.Add(transform.position);
            myMovement = new Movement(){myMovementList = listOfPosition};
            string json = JsonUtility.ToJson(myMovement);
            File.WriteAllText(FilePath, json);
        }

        if (playbackActive == true){

			TextAsset asset = Resources.Load (FilePath) as TextAsset;
			string dataAsJson = asset.text;
            Movement loadedData = JsonUtility.FromJson<Movement>(dataAsJson);
            loadedList = loadedData.myMovementList;
        PlayBack(loadedList);
        }

        listLength = loadedList.Count;

       // print ("x="+myTransform.localPosition.x);
       // print ("y="+myTransform.localPosition.y);
    }

    void Initiate () {
		vulnerable = false;
        StartCoroutine(Timer(Random.Range(0.0f,1f)));
    }

    IEnumerator Timer (float timer){
        yield return new WaitForSeconds(timer);
		StoppPlayback("irgendwohin");
		vulnerable = true;
    }

	IEnumerator Timer2 (float timer){
		yield return new WaitForSeconds(timer);
		playbackActive = true;
		vulnerable = true;
	}

    void PlayBack(List<Vector3> myList){
        //myTransform.position = myList[i]+prevPos;
        float myx = myTransform.position.x;
        float myY = myTransform.position.y;
        myx = myList[i].x+prevPos.x;
        myY = myList[i].y+prevPos.y;
        float myZ = myTransform.position.z;
        myZ = myTransform.position.y;
        myTransform.position = new Vector3(myx,myY,myZ);

		xDirection = 0.0f;
		yDirection = 0.0f;

		if (i != 0) {
			if (myList [i].x < myList [i - 1].x) {
				xDirection = -1.0f;
			} else if (myList [i].x > myList [i - 1].x) {
				xDirection = 1.0f;
			} else {
				xDirection = 0.0f;
			}

			if (myList [i].y < myList [i - 1].y) {
				yDirection = -1.0f;
			} else if (myList [i].y > myList [i - 1].y) {
				yDirection = 1.0f;
			} else {
				yDirection = 0.0f;
			}
		}

        i++;

        if (i == listLength){
			StoppPlayback ("irgendwohin");
        }

		// Animation
		if (Time.timeScale > 0.0f) {
			anim.SetFloat ("xSpeed", Mathf.Abs (xDirection));
			anim.SetFloat ("ySpeed", yDirection);
			spriteR.flipX = xDirection > 0.0f;
		}
    }

	public void StoppPlayback (string direction)
	{
		i = 0;
		prevPos = myTransform.position;
		playbackActive = false;
		//Debug.Log ("moving " + direction);
        float myZ = myTransform.position.z;
        myZ = myTransform.position.y;

        if (direction == "links"){
            ExportID = 1;
        }
        if (direction == "rechts"){
            ExportID = 2;
        }
        if (direction == "oben"){
            ExportID = 3;
        }
        if (direction == "unten"){
            ExportID = 4;
        }

        if (direction == "irgendwohin"){
            ExportID = Random.Range(5,Amount);
        }

		if (direction == "turn") {
			playbackActive = false;
			vulnerable = false;
			xDirection = 0.0f;
			yDirection = 0.0f;
			anim.SetFloat ("xSpeed", 0.0f);
			anim.SetFloat ("ySpeed", 0.0f);
			anim.SetInteger("Color", GetComponent<NPCScript>().fraction - 1);
			anim.SetTrigger("Change");
			StartCoroutine (Timer2 (1f));
		}
        
		if (direction != "Stopp" && direction != "turn") 
		{
			FilePath = "save"+ ExportID;
			playbackActive = true;
		}

	}


}
