﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using XInputDotNetPure;

public class PlayerController : MonoBehaviour {

	public int playerNumber;
	public VibrationManager vibrator;
	public AudioClip[] teleport;
	public GameObject particles;
	Animator anim;
	SpriteRenderer spriteR;


	private Vector3 moveDirection = Vector3.zero;
	private bool onCooldown = false;


	// Use this for initialization
	void Start () 
	{
//		if (vibrator.playerIndex == (PlayerIndex)0) {
//			playerNumber = 1;
//		} else if (vibrator.playerIndex == (PlayerIndex)1) {
//			playerNumber = 2;
//		}
		anim = GetComponent<Animator>();
		anim.SetInteger ("Color", playerNumber - 1);
		spriteR = GetComponent<SpriteRenderer>();
	}
	
	// Update is called once per frame

    void Update() 
	{
        CharacterController controller = GetComponent<CharacterController>();

		moveDirection = new Vector3(Input.GetAxis("Horizontal_JOYSTICK_" + playerNumber), Input.GetAxis("Vertical_JOYSTICK_" + playerNumber), 0);
            moveDirection = transform.TransformDirection(moveDirection);
			moveDirection *= GameManagerScript.globalSpeed;
		this.transform.position = new Vector3(transform.position.x,transform.position.y, transform.position.y);

        controller.Move(moveDirection * Time.deltaTime);

		if (Time.timeScale > 0.0f) {
			anim.SetFloat ("xSpeed", Mathf.Abs (Input.GetAxis ("Horizontal_JOYSTICK_" + playerNumber)));
			anim.SetFloat ("ySpeed", Input.GetAxis ("Vertical_JOYSTICK_" + playerNumber));
			spriteR.flipX = Input.GetAxis ("Horizontal_JOYSTICK_" + playerNumber) > 0.0f;
		}

		//Cooldown
		if (Input.GetButton ("Interact" + playerNumber)&& !onCooldown)
		{
			onCooldown = true;
			StartCoroutine("Cooldowntimer");
		}

    }

	void OnTriggerStay (Collider col)
	{		

		// teleport other player
		if (col.tag == "Player" && Input.GetButton ("Interact" + playerNumber) && col.gameObject != gameObject && !onCooldown) 
		{
			float x = Random.Range (-8.5f,8.5f);
			float y	= Random.Range (-4.5f,4.5f);

			if (!GetComponent<AudioSource> ().isPlaying) {
				
				GetComponent<AudioSource> ().PlayOneShot (teleport [Random.Range (0, teleport.Length)]);
				GameObject particleSys = Instantiate (particles, col.gameObject.transform.position, Quaternion.identity) as GameObject;
				var main = particleSys.GetComponent<ParticleSystem> ().main;
				if (playerNumber == 1) {
					main.startColor = new Color (240.0f / 255.0f, 76.0f / 255.0f, 39.0f / 255.0f);
				} else {
					main.startColor = new Color (0.0f, 1.0f, 0.46f);
				}
			}

			col.gameObject.transform.position = new Vector3 (x, y, y);


		}

		//turn NPC
		if (col.tag == "NPC" && Input.GetButton ("Fire"+playerNumber)) 
		{
			if (col.GetComponent<NPCScript> ().fraction != playerNumber && col.GetComponent<KI_Movement>().vulnerable)
			{
				vibrator.VibrationManage (playerNumber);

				col.GetComponent<NPCScript> ().fraction = playerNumber;
				col.GetComponent<KI_Movement> ().StoppPlayback ("turn");
			}
		}
	}

	IEnumerator Cooldowntimer ()
	{
		yield return new WaitForSeconds(1.5f);
		onCooldown = false;
	}
}
